package com.company.bpmnerror.service;

import org.flowable.engine.delegate.BpmnError;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import java.util.concurrent.*;

@Component
public class MyBpmService {

    private static final Logger log = LoggerFactory.getLogger(MyBpmService.class);

    public void testMethod() {
        ExecutorService executorService = Executors.newCachedThreadPool();
        Callable<String> task = this::longRunningMethod;
        Future<String> future = executorService.submit(task);
        try {
            future.get(10, TimeUnit.SECONDS);
        } catch (TimeoutException e) {
            log.info("longRunningMethod execution interrupted by timeout");
            throw new BpmnError("longTaskError", e.getMessage());
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        } catch (ExecutionException e) {
            throw new RuntimeException(e);
        } finally {
            future.cancel(true);
        }
        log.info("longRunningMethod execution completed");
    }

    private String longRunningMethod() {
        try {
            log.info("longRunningMethod execution started");
            TimeUnit.SECONDS.sleep(30);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
        return "result";
    }
}
